# ShadowMap

#### internal constructor new Cesium.ShadowMap()
engine/Source/Scene/ShadowMap.js 81

Use `Viewer#shadowMap` to get the scene's shadow map. Do not construct this directly.

The normalOffset bias pushes the shadows forward slightly, and may be disabled for applications that require ultra precise shadows.

##### Throws:

- DeveloperError : Only one or four cascades are supported.

##### Demo:

- Cesium Sandcastle Shadows Demo

### Members

#### darkness : number
engine/Source/Scene/ShadowMap.js 120

Determines the darkness of the shadows.

Default Value: `0.3`

#### enabled : boolean
engine/Source/Scene/ShadowMap.js 361

Determines if the shadow map will be shown.

Default Value: `true`

#### fadingEnabled : boolean
engine/Source/Scene/ShadowMap.js 129

Determines whether shadows start to fade out once the light gets closer to the horizon.

Default Value: `true`

#### maximumDistance : number
engine/Source/Scene/ShadowMap.js 137

Determines the maximum distance of the shadow map. Only applicable for cascaded shadows. Larger distances may result in lower quality shadows.

Default Value: `5000.0`

#### normalOffset : boolean
engine/Source/Scene/ShadowMap.js 378

Determines if a normal bias will be applied to shadows.

Default Value: `true`

#### size : number
engine/Source/Scene/ShadowMap.js 415

The width and height, in pixels, of each shadow map.

Default Value: `2048`

#### softShadows : boolean
engine/Source/Scene/ShadowMap.js 398

Determines if soft shadows are enabled. Uses pcf filtering which requires more texture reads and may hurt performance.

Default Value: `false`

Need help? The fastest way to get answers is from the community and team on the Cesium Forum.